/* DCJavaClient - a DirectConnect client written in Java
 * Copyright (C) 2001 Stefan Grling, stefan@gorling.se
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

import DCClientConnector;
import DCProtocolHandler;
import UserInfo;
import java.io.*;

/***

    Makes the connector threadable. Quick'n'dirty

***/

public class DCClientConnectorThread extends Thread {

    DCClientConnector DCC=null;
    boolean debug=false;
    DCClientProtocolHandler DCP=null;
    SearchResult file=null;
    public void run() {
	  try{
	  while (true) {
		DCC.openConnection();
		DCP=DCC.getProtocolHandler();
	      try{
	if (debug)
	      System.out.println("Starting to retrieve file");
	      if (file!=null) {
	if (debug)	
	  System.out.println("Starting to retrieve file");
		  if (!file.transferFinnished)
		      DCP.retrieveFile(file);
		  else {
	if (debug)
		      System.out.println("File already recieved, stopping thread");
		      this.stop();
		  }

	      }
	      }catch(IOException e) {
	if (debug)
		  System.out.println("File Downloader - Got exception, retrying"+e);
	      }
	      DCC.closeConnection();
	      Thread.sleep(20000,0);
	  }	  
	  }catch(Exception e) {
	      if (debug)
		System.out.println("Error:"+e);
	  }
    }

    public DCClientConnectorThread(String host, int port,UserInfo myself) {
	DCC=new DCClientConnector(host,port,myself);
    }

    public DCClientConnectorThread(SearchResult file,UserInfo myself) {
	this.file=file;
	DCC=new DCClientConnector(file,myself);
    }

    public SearchResult getDownloadStatus() {
	return file;
    }

    public void stopConnection() {
	DCP.logout();
	this.stop();
    }

    public void restartConnection() {
	if (DCP!=null)
	    DCP.logout(); // A closed connection will create a IOException which iwll force the download to restart. It's evil but works.
    }

    public boolean isConnected() {
	return DCC.isConnected();
    }

    public DCClientProtocolHandler getProtocolHandler() {
	return DCC.getProtocolHandler();
    }

}


