
/* DCJavaClient - a DirectConnect client written in Java
 * Copyright (C) 2001 Stefan Grling, stefan@gorling.se
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


import java.io.*;

class GeneralBufferedReader extends BufferedReader{
    /*** 
	 Works as a buffered reader, but readLine is customized so that the line separator is not required
     ***/

    String separator=null;
    final static int MAX_READAHEAD=16000; // max length of a command line, just made up.
    Reader in=null;

    public GeneralBufferedReader(Reader in, String separator) {
	super(in);
	this.separator=separator;
	this.in=in;
    }

    public GeneralBufferedReader(InputStreamReader in, String separator) {
	super(in);
	this.separator=separator;
	this.in=in;
    }

    public GeneralBufferedReader(InputStreamReader in, int sz,String separator) {
	super(in,sz);
	this.separator=separator;
    }

    public GeneralBufferedReader(Reader in, int sz,String separator) {
	super(in,sz);
	this.separator=separator;
    }

    public String readLine() throws IOException {
	// There is probably many more efficient ways to do this.
	String buffer=new String();
	
	while (!buffer.endsWith(separator)) {
	    buffer+=(char)read();
	}
	return buffer;
    }

    public boolean hasData() {
	return true; // There must be some way to se if there is data in the buffer.
    }

}


