/* DCJavaClient - a DirectConnect client written in Java
 * Copyright (C) 2001 Stefan Grling, stefan@gorling.se
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



import java.util.*;



/***

    @Description This class holds information about a search result and or the download status of it.
    @Version 0.20

 ***/

class SearchResult {

    String nick=null;
    String filename=null;
    int slots_used=0;
    int slots_max=3;
    long fileSize=0;
    UserInfo userInfo=null;
    String hub_name=null;
    String hub_ip=null;
    boolean transferInProgress=false;
    boolean transferFinnished=false;
    long bytesRecieved=0;
    int ipRequests=0;
    boolean mayResume=true;
    boolean debug=false;

    /***
	Takes a $SR Command data string as an argument.
     ***/

    public SearchResult (String sresult) {
	
	if (debug)
	System.out.println("Got:"+sresult);

	try{
	StringTokenizer st=new StringTokenizer(sresult,""+(char)5);
	String tmp=st.nextToken();
	nick=tmp.substring(0,tmp.indexOf(" "));
	filename=tmp.substring(tmp.indexOf(" ")+1,tmp.length());

	tmp=st.nextToken();
	fileSize=Long.parseLong(tmp.substring(0,tmp.indexOf(" ")));
	tmp=tmp.substring(tmp.indexOf(" ")+1,tmp.length());

	slots_used=Integer.parseInt(tmp.substring(0,tmp.indexOf("/")));
	slots_max=Integer.parseInt(tmp.substring(tmp.indexOf("/")+1,tmp.length()));

	}catch (Exception e) {
	    System.out.println("SearchResult ERror:"+e);
	}

    }

}


