/* DCJavaClient - a DirectConnect client written in Java
 * Copyright (C) 2001 Stefan Grling, stefan@gorling.se
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

import java.util.*;


/***

    @Description This class holds information about a certain user.
    @Version 0.20

 ***/


class UserInfo {
    String nick=null;
    String ip=null; // host:port
    String speed=null;
    String description=null;
    String email=null;
    long sharedBytes=0;
    int ipTries=0;


    /***
	Creates a UserInfo by a $MyINFO command data string
     ***/
    public UserInfo (String userinfo) {
	userinfo=userinfo.substring(5,userinfo.length());
	//I want regexps naitive in java... badly!

	StringTokenizer st=new StringTokenizer(userinfo,"$");	 
	String tmp=st.nextToken();
	nick=tmp.substring(0,tmp.indexOf(" "));
	description=tmp.substring(tmp.indexOf(" ")+1,tmp.length());
	tmp=st.nextToken(); // unknown info.
	speed=st.nextToken();


	if (st.countTokens()>1) {
	    email=st.nextToken();
	}

	sharedBytes=Long.parseLong(st.nextToken());
    }

    public UserInfo() {

    }

    public boolean equals(UserInfo userInfo) {
	if (this.nick==userInfo.nick)
	    return true;
	else
	    return false;
    }


    public String getNick() {
	return nick;
    }

    public boolean hasIP(String ip) {
	if (this.ip==null)
	    return false;
	if (this.ip.equals(ip))
	    return true;
	else
	    return false;
    }

    public String toString() {
	return "$ALL "+nick+" $ $"+speed+"$ $"+sharedBytes+"$";
    }

    public void setIP(String ip) {
	this.ip=ip;
    }

    public boolean hasNick(String nick) {
	if (this.nick==null)
	    return false;
	if (this.nick.equals(nick))
	    return true;
	else
	    return false;
    }
}








